/**
 * created by niujiahao on 2018/5/13
 */
/**
 * 首字母变大写，公共过滤器  alice →→→→→→→ Alice
 * @param {*value} value
 */

let capitalize = value => {
	if (!value) return ''
	value = value.toString()
	return value.charAt(0).toUpperCase() + value.slice(1)
}

/**
 * 保留两位小数
 * @param {*}  = [str]  字符格式价格  【价格由分转换成元，保留两位小数】
 */
let amountFloat = (str) => {
	var value = Math.round(parseFloat(str) * 100) / 100;
	var s = value.toString().split(".");
	if (s.length == 1) {
		value = value.toString() + ".00";
		return value;
	}
	if (s.length > 1) {
		if (s[1].length < 2) {
			value = value.toString() + "0";
		}
		return value;
	}
}

/**
 * 价格过滤格式
 * @param {*}  = [str]  字符格式价格  【价格由分转换成元，保留两位小数】
 */
let priceFloat = (str) => {
	var str1 = str / 100;
	var value = Math.round(parseFloat(str1) * 100) / 100;
	var s = value.toString().split(".");
	if (s.length == 1) {
		value = value.toString() + ".00";
		return value;
	}
	if (s.length > 1) {
		if (s[1].length < 2) {
			value = value.toString() + "0";
		}
		return value;
	}
}

/**
 * 格式化时间    20180202 →→→→→→→ 2018-02-02
 * @param {*value} value
 */
let dateServer = value => {

	var value = typeof value == "string" ? value : (value + '');

	return value.replace(/(\d{4})(\d{2})(\d{2})/g, '$1-$2-$3');
}

/**
 * 格式化时间
 */
let timeHadelSeconds = (value, format) => {
	if (value == 0 || value == "") {
		return "";
	}
	value = Number(value);
	if (isNaN(value)) {
		return "";
	}
	var value1 = value.length > 10 ? value : value * 1000;
	var d = new Date(value1);
	var year = d.getFullYear() < 10 ? '0' + d.getFullYear() : '' + d.getFullYear();
	var month = d.getMonth() + 1 < 10 ? '0' + Number(d.getMonth() + 1) : '' + Number(d.getMonth() + 1);
	var day = d.getDate() < 10 ? '0' + d.getDate() : '' + d.getDate();
	var hour = d.getHours() < 10 ? '0' + d.getHours() : '' + d.getHours();
	var minutes = d.getMinutes() < 10 ? '0' + d.getMinutes() : '' + d.getMinutes();
	var seconds = d.getSeconds() < 10 ? '0' + d.getSeconds() : '' + d.getSeconds();
	if (format == "YYYY-MM-DD") {
		return year + '-' + month + '-' + day;
	} else if (format == "MM-DD") {
		return month + '-' + day;
	} else if (format == "YYYY-MM-DD HH:MM:SS") {
		return year + '-' + month + '-' + day + '  ' + hour + ':' + minutes + ':' + seconds;
	} else if (format == "YYYY-MM-DD HH:MM") {
		return year + '-' + month + '-' + day + '  ' + hour + ':' + minutes;
	} else if (format == "HH:MM:SS") {
		return hour + ':' + minutes + ':' + seconds;
	} else if (format == "HH:MM") {
		return hour + ':' + minutes;
	}
}

/**
 * 格式化时间至日期
 */
let timeHadelDay = value => {
	if (value == 0 || value == "") {
		return "";
	}
	value = Number(value);
	if (isNaN(value)) {
		return "";
	}
	var value1 = value.length > 10 ? value : value * 1000;
	var d = new Date(value1);
	var year = d.getFullYear() < 10 ? '0' + d.getFullYear() : '' + d.getFullYear();
	var month = Number(d.getMonth()) + 1 < 10 ? '0' + Number(Number(d.getMonth()) + 1) : Number(d.getMonth()) + 1;
	var day = d.getDate() < 10 ? '0' + d.getDate() : '' + d.getDate();

	return year + '年' + month + '月' + day + '日'
}

let timeHadelDay2 = value => {
	if (value == 0 || value == "") {
		return "";
	}
	value = Number(value);
	if (isNaN(value)) {
		return "";
	}
	var value1 = value.length > 10 ? value : value * 1000;
	var d = new Date(value1);
	var year = d.getFullYear() < 10 ? '0' + d.getFullYear() : '' + d.getFullYear();
	var month = Number(d.getMonth()) + 1 < 10 ? '0' + Number(Number(d.getMonth()) + 1) : Number(d.getMonth()) + 1;
	var day = d.getDate() < 10 ? '0' + d.getDate() : '' + d.getDate();

	return year + '-' + month + '-' + day
}

/**
 * 格式化时间至分
 */
let timeHadelMin = value => {
	if (value == 0 || value == "") {
		return "";
	}
	value = Number(value);
	if (isNaN(value)) {
		return "";
	}
	var value1 = value.length > 10 ? value : value * 1000;
	var d = new Date(value1);
	var year = d.getFullYear() < 10 ? '0' + d.getFullYear() : '' + d.getFullYear();
	var month = Number(d.getMonth()) + 1 < 10 ? '0' + Number(Number(d.getMonth()) + 1) : Number(d.getMonth()) + 1;
	var day = d.getDate() < 10 ? '0' + d.getDate() : '' + d.getDate();
	var hour = d.getHours() < 10 ? '0' + d.getHours() : '' + d.getHours();
	var minutes = d.getMinutes() < 10 ? '0' + d.getMinutes() : '' + d.getMinutes();

	return year + '-' + month + '-' + day + '  ' + hour + ':' + minutes;
}

/**
 * 格式化时间差天数
 */
let rangHadelDay = value => {
	if (value == 0 || value == "") {
		return "";
	}
	value = Number(value);
	if (isNaN(value)) {
		return "";
	}
	var startTime = new Date().getTime(); //开始时间 
	var endTime = value.length > 10 ? value : value * 1000; //结束时间
	var date3 = endTime - startTime //时间差的毫秒数 
	var days = Math.floor(date3 / (24 * 3600 * 1000));
	return days
}

/**
 * 格式化毫秒
 */
let setTimeSeconds = value => {
	if (value == 0 || value == "") {
		return '00:00:00';
	}
	value = Number(value);
	if (isNaN(value)) {
		return '00:00:00';
	}
	var minute = 1000 * 60; //把分，时，天，周，半个月，一个月用毫秒表示
	var hour = minute * 60;
	var day = hour * 24;
	var diffValue = value;
	var resultTime = "";
	if (diffValue < 0) {
		resultTime = "数据异常";
	} else {
		var day2 = diffValue / day; //计算运行多少天
		var lestHour = diffValue % day; //计算剩余多少小时的毫秒
		var hour2 = lestHour / hour;
		var lestMin = lestHour % hour;
		var minute2 = lestMin / minute;
		var lestSecond = lestMin % minute;
		var second2 = lestSecond / 1000;

		if (parseInt(day2) == 0) {
			resultTime = parseInt(hour2) + ":" + parseInt(minute2) + ":" + parseInt(second2);
		} else if (parseInt(day2) == 0 && parseInt(hour2) == 0) {
			resultTime = "00:" + parseInt(minute2) + ":" + parseInt(second2);
		} else if (parseInt(minute2) == 0 && parseInt(hour2) == 0 && parseInt(day2) == 0) {
			resultTime = "00:00:" + parseInt(second2);
		} else {
			resultTime = parseInt(day2) + ":" + parseInt(hour2) + ":" + parseInt(minute2) + ":" + parseInt(second2);
		}
	}
	return resultTime;
}

/**
 * 格式化商品价格
 */
let toDecimal2 = value => {
	var f = parseFloat(value);
	if (isNaN(f)) {
		return false;
	}
	var f = Math.round(value * 100) / 100;
	var s = f.toString();
	var rs = s.indexOf('.');
	if (rs < 0) {
		rs = s.length;
		s += '.';
	}
	while (s.length <= rs + 2) {
		s += '0';
	}
	return s;
}

/**
 * 格式化商品价格按分
 */
let toDecimal2M = value => {
	var f = parseFloat(value);
	if (isNaN(f)) {
		return 0;
	}
	var f = Math.round(value * 100) / 100 / 100;
	var s = f.toString();
	var rs = s.indexOf('.');
	if (rs < 0) {
		rs = s.length;
		s += '.';
	}
	while (s.length <= rs + 2) {
		s += '0';
	}
	return s;
}
/**
 * 格式化商品价格按分
 */
let toDecimal2L = value => {
	var f = parseFloat(value);
	if (isNaN(f)) {
		return 0;
	}
	var f = Math.round(value * 100) / 100 / 100;
	var s = f.toString();
	var rs = s.indexOf('.');
	if (rs < 0) {
		rs = s.length;
		s += '.';
	}
	while (s.length <= rs + 2) {
		s += '0';
	}
	return s.split(".")[0];
}
/**
 * 格式化商品价格按分
 */
let toDecimal2R = value => {
	var f = parseFloat(value);
	if (isNaN(f)) {
		return 0;
	}
	let a = Math.floor(value * 100) / 100 / 100 //输出结果
	let s = a.toFixed(2).split(".")[1];
	if (s.lastIndexOf("0") == 1) {
		return s.substring(0, 1);
	} else {
		return s;
	}
}
let ellips = text => {
	if (text) {
		if (text.length < 10) {
			return text;
		} else if (text.length > 10 && text.length < 20) {
			return text.substring(0, 9) + '...';
		} else if (text.length > 20) {
			return text.substring(0, 20) + '...';
		} else {
			return text;
		}
	} else {
		return text;
	}
}
/**
 * 截取标题加省略号
 */
let ellipsText = (text, num) => {
	if (text) {
		if (text.length > num) {
			return text.substring(0, num) + '...';
		} else {
			return text;
		}
	} else {
		return text
	}
}

/**
 * 浏览量
 */
let computerLook = (num) => {
	if (!isNaN(num)) {
		num = Number(num);
		if (num > 10000) {
			num = (num / 10000).toFixed(2);
			return num + 'w';
		} else {
			return num;
		}
	} else {
		return 0;
	}
}
// 过滤表情
let valueEmoji = (value) => {
	return replace(/[^\a-\z\A-\Z0-9\u4E00-\u9FA5\@\.]/g, '')
}
export {
	capitalize,
	dateServer,
	timeHadelSeconds,
	timeHadelDay,
	timeHadelDay2,
	toDecimal2M,
	toDecimal2,
	toDecimal2L,
	toDecimal2R,
	setTimeSeconds,
	ellips,
	ellipsText,
	rangHadelDay,
	computerLook,
	priceFloat,
	amountFloat,
	timeHadelMin
}
