import md5 from "./md5.js";
import {Base64} from "./base.js";
// let API_URL= 'http://rcapi.dtjzwl.net/index.php/Api'
// let ADMIN_API = 'http://rcapi.dtjzwl.net/index.php/Api'
//https
let API_URL= 'https://api.bqrcy.com/index.php/Api'
let ADMIN_API = 'https://api.bqrcy.com/index.php/Api'
/*
	请求方法
	url '' 路径
	data {} 请求参数
	loadIs  是否有加载中的框
	errorMsgIs  是否提示错误信息
*/
const http = ({url="",method="GET",data={},loadIs=true,errorMsgIs=true,apiIs=true}={}) => {
	data.sign_key = md5('Bingqiwangluojiaoyupingtai946B@!');
	data.timetemps = Math.round(new Date() / 1000);
	data.loginStatus = uni.getStorageSync('loginStatus');
	data.operation_id = uni.getStorageSync('operation_id');
	if(data.loginStatus == ''){
		data.loginStatus = 1
	}
	let str = ''
	let code =  new Base64();
	data.sign = '';
	Object.values(data).forEach(key => {
		str += encodeURIComponent(key);
	})
	data.sign = md5(str);
	data.sign_key = '';
	if(data.password){
		data.password = code.encode(data.password);
	}
	if(data.password2){
		data.password2 = code.encode(data.password2);
	}
	uni.getNetworkType({
		success: (res) => {
			if (res.networkType == "none") {
				toastMessage({
					message: '请检查网络连接！',
				});
				return;
			}
		}
	});
	if(data.hasOwnProperty('userInfo')){
		if(uni.getStorageSync('userInfo')==''){
			uni.showToast({
				title: '请先登录',
				icon:"none",
				mask:true
			});
			setTimeout(()=>{
				uni.reLaunch({
					url: '/pages/login/login'
				});
			},1500)
			return false
		}
	}
	if(loadIs){
		uni.showLoading({
			title:"加载中",
			mask:true
		})
	}
	return new Promise((resolve, reject) => {
		uni.request({
			url: (apiIs?API_URL:ADMIN_API) + url,
			data: data,
			method: method,
			header:{"content-type":"application/x-www-form-urlencoded"},
			// header:{"content-type":"multipart/form-data"},
			complete: (res) => {
				if(res.data.operation_id){
					uni.setStorage({
						key: 'operation_id',
						data: res.data.operation_id
					});
				}
				uni.hideLoading();
				if (res.statusCode >= 200 && res.statusCode < 300) {
					if(res.data.error_msg){
						if(res.data.error_msg =='internal server error'){
							uni.showToast({
								title: '请求失败！',
								icon:'none'
							});
						} else {
							uni.showToast({
								title: res.data.error_msg,
								icon:'none'
							});
						}
						if(res.data.error_msg=='密码过期，请重新登录' || res.data.error_msg=='用户不存在' || res.data.error_code==103){
							uni.setStorage({
								key: 'loginStatus',
								data: res.data.status
							});
							uni.removeStorage({
								key: 'userInfo'
							});
							uni.removeStorage({
								key: 'userInfo_fen'
							});
							uni.removeStorage({
								key: 'user'
							});
							setTimeout(()=>{
								uni.reLaunch({
									url: '/pages/login/login'
								});
							},1500)
						}
						reject(res);
					}else{
						resolve(res.data)
					}
				} else {
					reject(res);
				}
			}
		});
	})
}

export default http
