import md5 from "./md5.js";
/* 验证码倒计时
that  this
time  倒计时时间
disable 是否禁止点击
*/
var codeDown = (that, time, disable) => {
    if (that[time] <= 1) {
        that[time] = 60;
        that[disable] = false;
        return false;
    }
    that[disable] = true
    that[time] = that[time] - 1
    setTimeout(() => {
        codeDown(that, time, disable)
    }, 1000)
}

/* 计算时间差
startTime  开始时间
endTime  结束时间
*/
let timeDifference = (startTime, endTime) => {
    var startTimes = new Date(startTime).getTime()
    var endTimes = new Date(endTime).getTime()
    // //console.log(startTimes,endTimes,endTime.replace(/-/g,'/'));
    var leftTime = Math.floor(parseInt(endTimes) - parseInt(startTimes)) / 1000
    //定义变量 d,h,m,s保存倒计时的时间
    var d = '00', h = '00', m = '00', s = '00';
    if (leftTime >= 0) {
        d = Math.floor(leftTime / 60 / 60 / 24) < 10 ? '0' + Math.floor(leftTime / 60 / 60 / 24) : Math.floor(leftTime / 60 / 60 / 24);
        h = Math.floor(leftTime / 60 / 60 % 24) < 10 ? '0' + Math.floor(leftTime / 60 / 60 % 24) : Math.floor(leftTime / 60 / 60 % 24);
        m = Math.floor(leftTime / 60 % 60) < 10 ? '0' + Math.floor(leftTime / 60 % 60) : Math.floor(leftTime / 60 % 60);
        s = Math.floor(leftTime % 60) < 10 ? '0' + Math.floor(leftTime % 60) : Math.floor(leftTime % 60);
    }
    return d + '天' + h + '小时' + m + '分钟' + s + '秒'
}

// 获取当前年第一天
let yearOneDay = () => {
    var date = new Date()
    return date.getFullYear() + '-01-01'
}
/**
 * 格式化时间
 * value 时间戳(秒)
 * format 时间格式(YYYY-MM-DD)
 */
let timeHadelSeconds = (value, format) => {
    if (value == 0 || value == "") {
        return "";
    }
    value = Number(value);
    if (isNaN(value)) {
        return "";
    }
    var value1 = value.length > 10 ? value : value * 1000;
    var d = new Date(value1);
    var year = d.getFullYear() < 10 ? '0' + d.getFullYear() : '' + d.getFullYear();
    var month = d.getMonth() + 1 < 10 ? '0' + Number(d.getMonth() + 1) : d.getMonth() + 1;
    var day = d.getDate() < 10 ? '0' + d.getDate() : '' + d.getDate();
    var hour = d.getHours() < 10 ? '0' + d.getHours() : '' + d.getHours();
    var minutes = d.getMinutes() < 10 ? '0' + d.getMinutes() : '' + d.getMinutes();
    var seconds = d.getSeconds() < 10 ? '0' + d.getSeconds() : '' + d.getSeconds();
    if (format == "YYYY-MM-DD") {
        return year + '-' + month + '-' + day;
    } else if (format == "YYYY-MM") {
        return year + '-' + month;
    } else if (format == "MM-DD") {
        return month + '-' + day;
    } else if (format == "YYYY-MM-DD HH:MM:SS") {
        return year + '-' + month + '-' + day + '  ' + hour + ':' + minutes + ':' + seconds;
    } else if (format == "YYYY-MM-DD HH:MM") {
        return year + '-' + month + '-' + day + '  ' + hour + ':' + minutes;
    } else if (format == "HH:MM:SS") {
        return hour + ':' + minutes + ':' + seconds;
    } else if (format == "HH:MM") {
        return hour + ':' + minutes;
    }
}
// html装换
let escape2Html = (str) => {
    if (str) {
        var arrEntities = {'lt': '<', 'gt': '>', 'nbsp': ' ', 'amp': '&', 'quot': '"'};
        return str.replace(/&(lt|gt|nbsp|amp|quot);/ig, function (all, t) {
            return arrEntities[t];
        }).replace(/<img/gi, '<img style="max-width:100%;height:auto;" ');
    } else {
        return ''
    }
}
/* 保留两位小数
value 要转换的值
*/
let returnFloat = (value) => {
    var value = Math.round(parseFloat(value) * 100) / 100;
    var xsd = value.toString().split(".");
    if (xsd.length == 1) {
        value = value.toString() + ".00";
        return value;
    }
    if (xsd.length > 1) {
        if (xsd[1].length < 2) {
            value = value.toString() + "0";
        }
        return value;
    }
}



// 热更新不会更新app的版本号
let updateVersion = (that) => {
	// 这里用一个常量定义（每次修改版本号将设置里面的版本号手动更新）
	let realVersion =  uni.getStorageSync('realVersion');
	if(realVersion == ''){
		realVersion = 1271
	}
	let version_url = that.$store.state.baseUrl + '/index/version';
	plus.runtime.getProperty(plus.runtime.appid, function(widgetInfo) {
		uni.request({
		    url: version_url,
			method: 'POST',
		    success: res => {
				if (res.data.code == -1) {
					let newVersion = res.data.msg.Version;
					let downloadUrl = res.data.msg.url;
					if (Number(realVersion) < Number(newVersion)) {
						uni.downloadFile({
							url: downloadUrl,
							success: (downloadResult) => {
							plus.runtime.install(downloadResult.tempFilePath, {force: true},
								function() {
								// 应用热重启，重新启动进入首页。
									plus.runtime.restart();
									uni.setStorage({
										key: 'realVersion',
										data: newVersion
									});
									// uni.showToast({
									// 	title: '安装成功,请重新打开进入应用',
									// 	icon: 'none',
									// 	duration: 2000
									// })
								},
								function(e) {
									uni.showToast({
										title: '安装失败',
										icon: 'none'
									})
								})
							},
							fail: (err) => {
								uni.showToast({
									title: '下载失败',
									icon: 'none'
								})
							}
						})
					}
				} else {
					uni.showToast({
						title: res.data.msg,
						icon: 'none'
					})
				}
			},
		    fail: (error) => {
		        console.log(error);
		    }
		});
	})
}
/* app版本升级
that  this
*/
let checkVersionClick = (that) => {
    // 获取版本信息
    let baseUrl = that.$store.state.baseUrl
    plus.runtime.getProperty(plus.runtime.appid, (widgetInfo) => {
        var platform = uni.getSystemInfoSync().platform //ios,android
        //根据当前平台去后台检测版本号
        if (platform == 'ios') {
			let data = {type: 2}
			data.key = md5('Bingqiwangluojiaoyupingtai946B@!');
			data.timetemps = Math.round(new Date() / 1000);
			let str = ''
			data.sign = '';
			Object.values(data).forEach(key => {
				str += encodeURIComponent(key);
			})
			data.sign = md5(str);
			data.key = '';
			re_url = baseUrl + '/index/ios_version';
			uni.request({
			    url: re_url,
				method: 'POST',
				data: data,
			    success: res => {
			        if (res.data.code == -1) {
			            let versionInfo = res.data.msg;
			            try {
			                plus.runtime.getProperty(plus.runtime.appid, wgtinfo => {
			                    let versionCode = wgtinfo.version.replace(/\./g, '');
			                    let updataVersion = versionInfo.edition.toString().replace(/\./g, '');
			                    if (versionCode && updataVersion && Number(updataVersion) > Number(versionCode)) {
			                        if (versionInfo.is_update == 2) {
			                            uni.showModal({
			                                title: '升级提示',
			                                content: '有新版本了，更新内容:'+versionInfo.content+'，当前版本:'+wgtinfo.version+'---->升级版本:'+versionInfo.edition,
			                                showCancel: true,
			                                //cancelText: '取消',
			                                confirmText: '升级',
			                                success: (res) => {
			                                    if (res.confirm) {
			                                        // 打开appstore
			                                        plus.runtime.openURL("https://apps.apple.com/cn/app/id1593573241");
			                                    } else {
													if (versionInfo.is_update == 2) {
														setTimeout(function () {
															plus.ios.import('UIApplication').sharedApplication().performSelector('exit');
														}, 1000);
													}
												}
			                                }
			                            })
			                        } else {
			                            uni.showModal({
			                                title: '升级提示',
			                                content: '有新版本了，更新内容:'+versionInfo.content+'，当前版本:'+wgtinfo.version+'---->升级版本:'+versionInfo.edition,
			                                showCancel: true,
			                                cancelText: '取消',
			                                confirmText: '升级',
			                                success: (res) => {
			                                    if (res.confirm) {
			                                        // 打开AppStore
			                                        plus.runtime.openURL("https://apps.apple.com/cn/app/id1593573241");
			                                    }
			                                }
			                            })
			                        }
			                    }
			                });
			            } catch (error) {
			            }
			        }
			    },
			    fail: (error) => {
			        console.log(error);
			    }
			});
        } else {
			let data = {type: 2}
			data.key = md5('Bingqiwangluojiaoyupingtai946B@!');
			data.timetemps = Math.round(new Date() / 1000);
			let str = ''
			data.sign = '';
			Object.values(data).forEach(key => {
				str += encodeURIComponent(key);
			})
			data.sign = md5(str);
			data.key = '';
            uni.request({
                url: baseUrl + '/index/edition',
				method: 'POST',
				data: data,
                success: res => {
                    if (res.data.code == -1) {
                        let versionInfo = res.data.msg;
                        try {
                            plus.runtime.getProperty(plus.runtime.appid, wgtinfo => {
                                let versionCode = wgtinfo.version.replace(/\./g, '');
                                let updataVersion = versionInfo.edition.toString().replace(/\./g, '');
                                let url = res.data.msg.url
                                // TODO 逻辑加固，防止强制更新
                                if (versionCode && updataVersion && Number(updataVersion) > Number(versionCode)) {
                                    if (versionInfo.is_update == 2) {
                                        uni.showModal({
                                            title: '升级提示',
                                            content: '有新版本了，更新内容:'+versionInfo.content+'，当前版本:'+wgtinfo.version+'---->升级版本:'+versionInfo.edition,
                                            showCancel: true,
                                            //cancelText: '取消',
                                            confirmText: '升级',
                                            success: (res) => {
                                                if (res.confirm) {
                                                    // 下载新版本APK
                                                    uni.showLoading({
                                                        title: '下载中请稍后',
                                                        mask: true
                                                    })
                                                    plus.runtime.openURL(url);
                                                    uni.hideLoading();
                                                    let updata = plus.downloader.createDownload(url, {}, function (d, status) {
                                                        uni.hideLoading();
                                                        if (status === 200) {
                                                            plus.runtime.install(plus.io.convertLocalFileSystemURL(d.filename), {}, {}, function (error) {
                                                                uni.showToast({
                                                                    title: '安装失败',
                                                                    mask: false,
                                                                    duration: 1500,
                                                                    icon: 'none'
                                                                });
                                                            })
                                                        } else {
                                                            uni.showToast({
                                                                title: '更新失败',
                                                                mask: false,
                                                                duration: 1500,
                                                                icon: 'none'
                                                            });
                                                        }
                                                    });
                                                    updata.start();
                                                } else {
                                                    if (versionInfo.is_update == 2) {
                                                        plus.runtime.quit();
                                                    }
                                                }
                                            }
                                        })
                                    } else {
                                        uni.showModal({
                                            title: '升级提示',
                                            content: '有新版本了，更新内容:'+versionInfo.content+'，当前版本:'+wgtinfo.version+'---->升级版本:'+versionInfo.edition,
                                            showCancel: true,
                                            cancelText: '取消',
                                            confirmText: '升级',
                                            success: (res) => {
                                                if (res.confirm) {
                                                    // 下载新版本APK
                                                    uni.showLoading({
                                                        title: '下载中请稍后',
                                                        mask: true
                                                    })
                                                    plus.runtime.openURL(url);
                                                    uni.hideLoading();
                                                    let updata = plus.downloader.createDownload(url, {}, function (d, status) {
                                                        uni.hideLoading();
                                                        if (status === 200) {
                                                            plus.runtime.install(plus.io.convertLocalFileSystemURL(d.filename), {}, {}, function (error) {
                                                                uni.showToast({
                                                                    title: '安装失败',
                                                                    mask: false,
                                                                    duration: 1500,
                                                                    icon: 'none'
                                                                });
                                                            })
                                                        } else {
                                                            uni.showToast({
                                                                title: '更新失败',
                                                                mask: false,
                                                                duration: 1500,
                                                                icon: 'none'
                                                            });
                                                        }
                                                    });
                                                    updata.start();
                                                } else {
                                                    // if (versionInfo.is_update == 2) {
                                                    //     plus.runtime.quit();
                                                    // }
                                                }
                                            }
                                        })
                                    }
                                }
                            });
                        } catch (error) {
                        }
                    }
                },
                fail: (error) => {
                    
                }
            });
        }
    });
}
/* 文件预览
*fileUrl  文件路径
*/
let filePreview = (fileUrl) => {
    //console.log(fileUrl);
    uni.showLoading({
        title: "加载中",
        mask: true
    })
    uni.downloadFile({
        url: fileUrl,
        success: function (res) {
            uni.hideLoading()
            var filePath = res.tempFilePath;
            uni.openDocument({
                filePath: filePath,
                success: function (res) {
                    //console.log('打开文档成功');
                }
            });
        },
        fail: function (err) {
            uni.hideLoading()
        }
    });
}
/*文件下载
*fileUrl  文件路径
*/
let fileDownload = (fileUrl) => {
    uni.showLoading({
        title: "加载中",
        mask: true
    })
    uni.downloadFile({
        url: fileUrl, //仅为示例，并非真实的资源
        success: (res) => {
            // //console.log(res);
            if (res.statusCode === 200) {
                uni.saveFile({
                    tempFilePath: res.tempFilePath,
                    success: function (res1) {
                        // uni.showToast({
                        // 	title: '保存成功'
                        // });
                        uni.hideLoading()
                        var savedFilePath = res1.savedFilePath;
                        plus.io.resolveLocalFileSystemURL(savedFilePath, function (entry) {
                            entry.file(function (file) {
                                var fileReader = new plus.io.FileReader();
                                uni.showToast({
                                    title: '文件保存到' + file.fullPath,
                                    icon: 'none'
                                });
                                //console.log(JSON.stringify(file));
                            })
                        }, function (e) {
                            //console.log("Request file system failed: " + e.message);
                        });
                    },
                    fail(err) {
                        //console.log(JSON.parse(err));
                    }
                });
            }
        },
        fail: (err) => {
            //console.log(err);
            uni.hideLoading()
        }
    });
}
// 下载图片到相册
// photoUrl  图片路径
let photoDownload = (photoUrl) => {
    let filename = Math.random() + ".jpg"

    plus.downloader.createDownload(photoUrl, {
        filename: "_downloads/" + filename
    }, (download, status) => {
        //console.log(download, status);
        if (status == 200) {//下载成功
            plus.gallery.save(download.filename, () => {
                uni.hideLoading();
                uni.showToast({
                    title: '保存成功！'
                });
            })
        }
    }).start()
}
/* 获取scrollview高度
that this 
navHeight nav高度
*/
let getScrollHeight = (that, navHeight) => {
    uni.getSystemInfo({
        success: e => {
            that.scrollHeight = e.screenHeight - e.statusBarHeight - uni.upx2px(navHeight);
        }
    });
}

/* 倒计时
value  结束时间
that   this
countDown  赋值给data里的数据
*/
let timeCountDown = (value, that, countDown, totalSecond) => {
    //结束时间
    var endDate = value;
    //当前时间
    var nowDate = new Date().getTime();

    //相差的总秒数
    var totalSeconds = parseInt((endDate - nowDate) / 1000);
    that[totalSecond] = totalSeconds
    if (totalSeconds <= 0) {
        that[countDown] = '00:00:00';
        return false
    }
    //天数
    var days = Math.floor(totalSeconds / (60 * 60 * 24)) < 10 ? '0' + Math.floor(totalSeconds / (60 * 60 * 24)) : Math.floor(totalSeconds / (60 * 60 * 24));
    //取模（余数）
    var modulo = totalSeconds % (60 * 60 * 24);
    //小时数
    var hours = Math.floor(modulo / (60 * 60)) < 10 ? '0' + Math.floor(modulo / (60 * 60)) : Math.floor(modulo / (60 * 60));
    modulo = modulo % (60 * 60);
    //分钟
    var minutes = Math.floor(modulo / 60) < 10 ? '0' + Math.floor(modulo / 60) : Math.floor(modulo / 60);
    //秒
    var seconds = modulo % 60 < 10 ? '0' + modulo % 60 : modulo % 60;
    //输出到页面
    that[countDown] = hours + ':' + minutes + ':' + seconds;

    //延迟一秒执行自己
    setTimeout(function () {
        timeCountDown(value, that, countDown, totalSecond);
    }, 1000)
}
// 拨打电话
// phoneNumber  拨打电话 
let makePhoneCall = (phoneNumber) => {
    uni.makePhoneCall({
        phoneNumber: phoneNumber //仅为示例
    });
}
// 各种校验
let verifyRules = {
    // 手机号验证
    mobile(mobile) {
        let myreg = /^[1][0-9][0-9]{9}$/;
        return (mobile == "" ? '手机号不能为空' : '') || (!myreg.test(mobile) ? '手机号输入有误,请重新输入' : '') || true
    },
    // 验证码验证
    code(code) {
        return code == "" ? '验证码不能为空' : true
    },
    // 姓名验证
    // #ifndef APP-PLUS
    user_name(user_name) {
        // return user_name==""?'用户名不能为空':''||true
        return user_name == "" ? '用户名不能为空' : '' || (user_name.length > 6 || user_name.charCodeAt() < 255 ? '用户名输入有误' : '') || true
    },
    // #endif
    pass: "",
    // 密码验证
    password(pass) {
        let myreg = /((^(?=.*[a-z])(?=.*[A-Z])(?=.*\W)[\da-zA-Z\W]{11,}$)|(^(?=.*\d)(?=.*[A-Z])(?=.*\W)[\da-zA-Z\W]{11,}$)|(^(?=.*\d)(?=.*[a-z])(?=.*\W)[\da-zA-Z\W]{11,}$)|(^(?=.*\d)(?=.*[a-z])(?=.*[A-Z])[\da-zA-Z\W]{11,}$))/;
        verifyRules.pass = pass
		let match = /(123|234|345|456|567|678|789|abc|abcd)/
        return (pass.length < 11 || pass.length > 20 ? '密码长度应为11到20位之间' : '') || (match.test(pass) ? '密码不可使用连续简单字符,如:123 456 789 abc等..请及时修改' : '') || (pass == "" ? '密码不能为空' : '') || (!myreg.test(pass) ? '密码至少包含数字、大写字母、小写字母、特殊字符中的三种类型' : '') || true
    },
    // 再次输入密码
    password2(pass2) {
        return (pass2 == "" ? '请再次输入密码' : '') || (pass2 != verifyRules.pass ? '两次密码输入不一致,请重新输入' : '') || true
    },
    // 身份证验证
    // #ifndef APP-PLUS
    id_number(id_number) {
        var numReg = /(^\d{15}$)|(^\d{18}$)|(^\d{17}(\d|X|x)$)/;
        return (id_number == "" ? '身份证号不能为空' : '') || (!numReg.test(id_number) ? '身份证号输入有误,请重新输入' : '') || true
    },
    // #endif
}

let verifyReg = (data) => {
    for (let key in data) {
        for (let key2 in verifyRules) {
            if (key == key2 && verifyRules[key2](data[key]) !== true) {
                uni.showToast({
                    title: verifyRules[key2](data[key]),
                    icon: "none"
                })
                return false
            }
        }
    }
    return true
}

// h5网站提示
let h5Toast = () => {
    uni.showToast({
        title: '请在App中打开！',
        icon: "none"
    });
}
// 权限控制
// level  首页判断
let limits = (that, item, level) => {
    return true
}


module.exports = {
	updateVersion,
    timeHadelSeconds,
    escape2Html,
    checkVersionClick,
    returnFloat,
    filePreview,
    fileDownload,
    getScrollHeight,
    yearOneDay,
    timeDifference,
    codeDown,
    timeCountDown,
    makePhoneCall,
    verifyReg,
    photoDownload,
    limits,
    h5Toast
}
